{# Client Settings #}

{% include "nomad-base-config.hcl.j2" %}

advertise { 
  http = "{{ nomad_client_address }}" 
}

client {
  enabled = true
  network_interface = "{{ packer_vars.nomad_network_interface }}"
  {% for server in nomad_servers %}
    {% set _ = packer_vars.nomad_server_join.append(hostvars[server]['nomad_bind_address']) %}
  {% endfor %}
  servers = [
  {% for address in packer_vars.nomad_server_join | map('ansible.utils.ipwrap') %}
    "{{ address }}:4647"{% if not loop.last %},{% endif %}
  {% endfor %}

  ]
  server_join {
    retry_join = [
    {% for address in packer_vars.nomad_server_join | map('ansible.utils.ipwrap') %}
      "{{ address }}"{% if not loop.last %},{% endif %}
    {% endfor %}
    
    ]
  }
  host_volume "shared-tls" {
    path      = "{{ nomad_tls_certs_shared_path }}"
    read_only = true
  }
  {% for nomad_host_volume in packer_vars.nomad_client_host_volumes %}
  host_volume "{{ nomad_host_volume.name }}" {
      path = "{{ nomad_host_volume.path }}"
      read_only = {{ nomad_host_volume.read_only | lower }}
  }
  {% endfor %}
  {% for nomad_host_network in packer_vars.nomad_client_host_networks %}
  host_network "{{ nomad_host_network.name }}" {
  {% if 'cidr' in nomad_host_network %}
      cidr = "{{ nomad_host_network.cidr }}"
  {% else %}
      interface = "{{ nomad_host_network.interface }}"
  {% endif %}
  {% if 'reserved_ports' in nomad_host_network %}
      reserved_ports = "{{ nomad_host_network.reserved_ports }}"
  {% endif %}
  }
  {% endfor %}
  {% if nomad_options %}
  options = {
  {% for key, value in nomad_options.items() %}
    "{{ key }}" = "{{ value }}"
  {% endfor %}
  }
  {% endif %}
  {% if nomad_meta %}
  meta = {
  {% for key, value in nomad_meta.items() %}
    "{{ key }}" = "{{ value }}"
  {% endfor %}
  }
  {% endif %}
}

plugin "docker" {
  config {
    volumes {
      enabled = true
    }
  }
}

tls {
  http = true
  rpc  = true

  ca_file   = "{{ nomad_tls_certs_path }}/{{ nomad_tls_ca_file }}"
  cert_file = "{{ nomad_tls_certs_path }}/{{ nomad_tls_cert_file }}"
  key_file  = "{{ nomad_tls_certs_path }}/{{ nomad_tls_key_file }}"

  verify_server_hostname = false
  verify_https_client    = true
}

{% include "consul-block/consul-client-config.hcl.j2" %}